﻿; Fate2-Framery
; Copyright (C) 2019 Dragonfly
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;
;
;- Declaration: Constants
;
#VRSN  = "1.0.0."
#WIN   = 0
#WIN_W = 480
#WIN_H = 300
#WIN_T = "Fate2-Framery v." + #VRSN
#WIN_F = #PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_Invisible
;
#BAR           = 0
#BAR_FLD_INFO  = 0
#BAR_FLD_COPY  = 1
#BAR_TXT_COPY  = "© 2019, by Dragonfly"
;
#ROOT          = "C:\"
#FILE_IN       = 0
#FILE_OUT      = 1
#FILE_NONE     = -1
#FILE_MIN      = 1024 * 512
#FILE_MAX      = 1024 * 1024 * 5
#VALS_MAX      = 20
;
Enumeration; Function: SetStatus()
  #STS_EMPTY
  #STS_INIT_OK
  #STS_FILE_NONE
  #STS_FILE_WRONG
  #STS_FILE_ERROR
  #STS_FILE_LOAD
  #STS_PROC_START
  #STS_PROC_CNCLD
  #STS_PROC_SUCCS
EndEnumeration 
;
Enumeration; Function: Error()
  #ERR_FILE_SIZE
  #ERR_FILE_OPEN
  #ERR_FILE_READ
  #ERR_MEM_ALLOC
EndEnumeration
;
Enumeration; Gadgets/Controls
  #FRM_ALL
  #G_CNT_FILE
    #G_FRM_FILE
    #G_BTN_FILE
    #G_STR_FILE
    #G_CHK_FILE
    #G_CHK_WIND
    #G_BTN_START
  #G_CNT_PRGS
    #G_FRM_PRGS
    #G_LST_PRGS
  #G_CNT_VALS
    #G_FRM_VALS
    #G_LST_VALS
    #G_BTN_VALS
EndEnumeration
;
Enumeration
  #MODE_INIT
  #MODE_CHNG
  #MODE_FULL
EndEnumeration

;- Declaration: Structures
;
Structure STUFF
  pathExe.s
  folderExe.s
  sizeExe.i
  *memExe
  valsNumInit.i
  valsNumChng.i
  valsNumFull.i
  valsOffInit.i[#VALS_MAX]
  valsOffChng.i[#VALS_MAX]
  valsOffFull.i[#VALS_MAX]
  valInit1User.i
  valInit2User.i
  valChng1User.i
  valFull1User.i
  valFull2User.i
  curMode.i
EndStructure
;
;- Declaration: Variables (shared)
;
Define prog.STUFF
Dim    valsInit.i(5)
Dim    valsChng.i(5)
Dim    valsFull.i(5)
;
;- Declaration: Procedures
;
Declare   Main()
Declare   SubMain()
Declare   Init()
Declare   CreateGUI()
Declare   GadgetControl(gadget.i)
Declare.i GadgetControl2(gadget.i)
Declare   SetStatus(statusCode.i, extra.s = "")
Declare   Error(errorCode.i, extra.s = "", quit.i = #False)
Declare   Quit()
;
Declare   GetExecutable()
Declare.i LoadExecutable()
Declare.i BackupExecutable()
Declare.i PatchExecutable()
;
Declare   Start()
Declare.i DoSearch()
Declare   Resume()
Declare   DoPatch()
Declare   SetStartStates(state.i)
Declare.i SetListEntry(text.s, pos.i = -1)
Declare   FillListVals()
Declare   CheckListVals()
Declare.i SearchValuesInit()
Declare.i SearchValuesChange()
Declare.i SearchValuesFull()
;
; IDE Options = PureBasic 4.41 (Windows - x64)
; EnableXP
; EnableBuildCount = 0