﻿; Fate2-Framery
; Copyright (C) 2019 Dragonfly
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;
;
;Title       : Fate2-Framery
;
;Compiler    : PureBasic v.4.41
;Platform    : Windows (Tested: 7, 10)
;System      : 32 Bit(x86),64-Bit(x64)
;Win-API     : DPI_AWARE.pbi
;D.o.C       : 08.09.2019
;Last Update : 15.09.2019
;Version     : v.1.0.0.1
;Creator     : Dragonfly
;Licence     : GNU GPL3
;
;Version-History:
;
;Version 1.0.0.1
; - Initial-Release
;
;ToDo:
; - 
;
;
EnableExplicit
;
XIncludeFile "Framery.h"
XIncludeFile "DPI_Aware.pbi" 
;
;-
;Start Program
Init()
Main()
;
;----------------------------------------------->
;- Procedures (Common):
;-
;
;*
; Main()
; Mainloop: Catch & delegate events
; 
; @param  void
; @return void
;**
Procedure Main()
;  
Repeat
  Select WaitWindowEvent()
    Case #PB_Event_Gadget      : GadgetControl(EventGadget())
    Case #PB_Event_CloseWindow : Quit()
  EndSelect
ForEver
;
EndProcedure
;
;*
; SubMain()
; Subloop: Catch & delegate events
; 
; @param  void
; @return void
;**
Procedure SubMain()
;
Repeat
  Select WaitWindowEvent()
    Case #PB_Event_Gadget      : If (GadgetControl2(EventGadget())) : Break : EndIf
    Case #PB_Event_CloseWindow : Quit()
  EndSelect
ForEver
;
EndProcedure
;
;*
; Init()
; Program-initialisation
; 
; @param  void
; @return void
;**
Procedure Init()
Shared prog.STUFF
Shared valsInit.i()
Shared valsChng.i()
Shared valsFull.i()
;
prog\folderExe    = #ROOT
prog\valInit1User = 0
prog\valInit2User = 1
prog\valChng1User = 0
prog\valFull1User = 0
prog\valFull2User = 1
;
valsInit(0) = $68
valsInit(1) = $00
valsInit(2) = $00
valsInit(3) = $CF
valsInit(4) = $00
valsInit(5) = $68
;
valsChng(0) = $68
valsChng(1) = $00
valsChng(2) = $00
valsChng(3) = $CF
valsChng(4) = $10
valsChng(5) = $6A
;
valsFull(0) = $68
valsFull(1) = $00
valsFull(2) = $00
valsFull(3) = $04
valsFull(4) = $10
valsFull(5) = $6A
;
InitDPI()
CreateGUI()
SetStatus(#STS_INIT_OK)
;
EndProcedure
;
;*
; CreateGUI()
; Creates the control-elements
; 
; @param  void
; @return void
;**
Procedure CreateGUI()
Protected.i width
;
OpenWindow(#WIN, 0, 0, #WIN_W, #WIN_H, #WIN_T + Str(#PB_EDITOR_BUILDCOUNT), #WIN_F)
CreateStatusBar(#BAR, WindowID(#WIN))
  AddStatusBarField(#PB_Ignore)
  AddStatusBarField(#WIN_W * 0.3)
  StatusBarText(#BAR, #BAR_FLD_COPY, #BAR_TXT_COPY)
ResizeWindow(#WIN, #PB_Ignore, #PB_Ignore, ScaleX(#WIN_W), ScaleY(#WIN_H + StatusBarHeight(#BAR)))  
;
Frame3DGadget(#FRM_ALL, 0, 0, #WIN_W-1, #WIN_H-2,"", #PB_Frame3D_Single)
;
ContainerGadget(#G_CNT_FILE, 2, 2, #WIN_W-4, 139)
  width = GadgetWidth(#G_CNT_FILE)
  Frame3DGadget(#G_FRM_FILE, 5, 10, width-10, 124, "Auswahl")
  ButtonGadget(#G_BTN_FILE, 15, 30, 100, 20, "Fate2 Executable")
  StringGadget(#G_STR_FILE, 125, 31, width - 140, 20, "", #PB_String_ReadOnly)
  CheckBoxGadget(#G_CHK_FILE, 125, 55, width - 140, 20, "Backup erstellen: Fate2_back.exe")
  CheckBoxGadget(#G_CHK_WIND, 125, 79, width - 140, 20, "Fenster: Kein Resize, Rahmen schmal")
  ButtonGadget(#G_BTN_START, 15, 104, 100, 20, "Start")
CloseGadgetList()
;
ContainerGadget(#G_CNT_PRGS, 2, 140, #WIN_W-4, #WIN_H-144)
  width = GadgetWidth(#G_CNT_PRGS)
  Frame3DGadget(#G_FRM_PRGS, 5, 10, width-10, #WIN_H-158, "Fortschritt")
  ListViewGadget(#G_LST_PRGS, 15, 30, width-30, #WIN_H-185)
CloseGadgetList()
;
ContainerGadget(#G_CNT_VALS, 2, 140, #WIN_W-4, #WIN_H-144)
  width = GadgetWidth(#G_CNT_VALS)
  Frame3DGadget(#G_FRM_VALS, 5, 10, width-10, #WIN_H-158, "")
  ListViewGadget(#G_LST_VALS, 15, 30, width-130, #WIN_H-185, #PB_ListView_ClickSelect)
  ButtonGadget(#G_BTN_VALS, width-100, #WIN_H-174, 80, 20, "Ok")
CloseGadgetList()
;
HideGadget(#G_CNT_VALS, #True)
DisableGadget(#G_BTN_START, #True)
DisableGadget(#G_LST_PRGS,  #True)
DisableGadget(#G_BTN_VALS, #True)
;
WindowScaleDPI(#WIN)
HideWindow(#WIN, #False)
;
EndProcedure
;
;*
; GadgetControl(gadget.i)
; Turns gadget-events into functions.
; 
; @param  Int:  gadget-events provided from mainloop
; @return void
;**
Procedure GadgetControl(gadget.i)
;
Select gadget
  Case #G_BTN_FILE  : GetExecutable()
  Case #G_BTN_START : Start()
  Case #G_LST_VALS  : CheckListVals()
  Case #G_BTN_VALS  : 
EndSelect
;
EndProcedure
;
;*
; GadgetControl2(gadget.i)
; Turns gadget-events into functions.
; 
; @param  Int:  gadget-events provided from mainloop
; @return bool
;**
Procedure.i GadgetControl2(gadget.i)
;
Select gadget
  Case #G_LST_VALS  : CheckListVals()
  Case #G_BTN_VALS  : ProcedureReturn #True
EndSelect
;
EndProcedure
;
;*
; SetStatus(statusCode.i, extra.s = "")
; Shortcut to place a message in the "user-information-field" of the statusbar
; 
; @param Int:      statusID (constant: s. Enumerations)
; @param String:  (optional) additional information
; @return void
;**
Procedure SetStatus(statusCode.i, extra.s = "")
Protected.s msg
;  
Select statusCode
  Case #STS_EMPTY      : msg =  ""   
  Case #STS_INIT_OK    : msg = "Programm initialisiert"
  Case #STS_FILE_NONE  : msg = "Keine Datei ausgewählt"
  Case #STS_FILE_WRONG : msg = "Ungültige Datei ausgewählt"
  Case #STS_FILE_ERROR : msg = "Dateifehler"
  Case #STS_FILE_LOAD  : msg = "Datei geladen"
  Case #STS_PROC_START : msg = "Vorgang gestartet..."
  Case #STS_PROC_CNCLD : msg = "Vorgang abgebrochen"
  Case #STS_PROC_SUCCS : msg = "Vorgang erfolgreich"
EndSelect
; 
StatusBarText(#BAR, #BAR_FLD_INFO, msg)
;
EndProcedure
;
;*
; Error(errorCode.i, extra.s = "", quit.i = #False)
; Informs the user via MessageRequester() about an occured error,
; with option to quit program on "fatal errors"
; 
; @param  Int:       errorID (constant: s. Enumerations)
; @param  String:   (optional) additional informations
; @param  Boolean:  (optional) set '#True' to quit program
; @return void
;**
Procedure Error(errorCode.i, extra.s = "", quit.i = #False)
Protected.s msg
;
Select errorCode
  Case #ERR_FILE_SIZE : msg = "Datei: '" + extra + "'" + #CRLF$ + "hat falsche Größe."
  Case #ERR_FILE_OPEN : msg = "Datei: '" + extra + "'" + #CRLF$ + "konnte nicht geöffnet werden"
  Case #ERR_FILE_READ : msg = "Datei: '" + extra + "'" + #CRLF$ + "konnte nicht gelesen werden"
  Case #ERR_MEM_ALLOC : msg = "Speicher konnte nicht reserviert werden."
EndSelect
;
MessageRequester("Fehler", msg)
If (quit) : End : EndIf
;
EndProcedure 
;
;*
; Quit()
; Quit program
; 
; @param  void  
; @return void
;**
Procedure Quit()
;
End
;  
EndProcedure
;
;-
;***
;----------------------------------------------->
;- Procedures (Logic):
;-
;
;*
; GetExecutable()
; Get the location of 'Fate2.exe' and load it into memory
; 
; @param  void  
; @return void
;**
Procedure GetExecutable()
Protected.s result
Shared      prog.STUFF
;
result = OpenFileRequester("Fate2 Executable auswählen", prog\folderExe, "Fate2.exe (Fate2.exe)|Fate2.exe", 0)
;
If (result = #NULL$)
  SetStatus(#STS_FILE_NONE)
  ProcedureReturn
EndIf
;
prog\pathExe   = result
prog\folderExe = RTrim(GetPathPart(result), "\") + "\"
prog\sizeExe   = FileSize(result)
;
If ((prog\sizeExe = #FILE_NONE) Or (prog\sizeExe < #FILE_MIN) Or (prog\sizeExe >= #FILE_MAX))
  Error(#ERR_FILE_SIZE, result)
  SetStatus(#STS_FILE_WRONG)
  ProcedureReturn
EndIf
;
SetGadgetText(#G_STR_FILE, result)
SetGadgetState(#G_CHK_FILE, #False)
;
If (FileSize(prog\folderExe + "fate2_back.exe") = #FILE_NONE)
  DisableGadget(#G_CHK_FILE, #False)
Else
  DisableGadget(#G_CHK_FILE, #True)
EndIf
;
If (Not LoadExecutable())
  SetStatus(#STS_FILE_ERROR)
  DisableGadget(#G_BTN_START, #True)
  ProcedureReturn
EndIf
;
SetStatus(#STS_FILE_LOAD)
DisableGadget(#G_BTN_START, #False)
;
EndProcedure
;
;*
; LoadExecutable()
; Load the content of the 'Fate2.exe' into memory
; 
; @param  void  
; @return bool
;**
Procedure.i LoadExecutable()
Protected.i result, size
Shared      prog.STUFF
;
If (prog\memExe)
  FreeMemory(prog\memExe)
EndIf
;
prog\memExe = AllocateMemory(prog\sizeExe)
;
If (Not prog\memExe)
  Error(#ERR_MEM_ALLOC)
  ProcedureReturn
EndIf
;
If (Not ReadFile(#FILE_IN, prog\pathExe))
  Error(#ERR_FILE_OPEN, prog\pathExe)
  ProcedureReturn
EndIf
;
size = ReadData(#FILE_IN, prog\memExe, prog\sizeExe)
CloseFile(#FILE_IN)
;
If (size <> prog\sizeExe)
  Error(#ERR_FILE_READ, prog\pathExe)
  ProcedureReturn
EndIf
;
ProcedureReturn #True
EndProcedure
;
;*
; BackupExecutable()
; Make a backup of the 'Fate2.exe'
; 
; @param  void  
; @return bool: 
;**
Procedure.i BackupExecutable()
Protected.s backFile
Shared      prog.STUFF
;
backFile = prog\folderExe + "fate2_back.exe"
;
ProcedureReturn CopyFile(prog\pathExe, backFile)
EndProcedure
;
;*
; PatchExecutable()
; Well...
; 
; @param  void  
; @return bool: 
;**
Procedure.i PatchExecutable()
Shared prog.STUFF
;
If (Not OpenFile(#FILE_OUT, prog\pathExe))
  Error(#ERR_FILE_OPEN, prog\pathExe)
  ProcedureReturn
EndIf
;
If (prog\valsNumInit = 1)
  FileSeek(#FILE_OUT, prog\valsOffInit[0] + 1)
  WriteLong(#FILE_OUT, $00CB0001)
ElseIf (prog\valsNumInit > 1)
  FileSeek(#FILE_OUT, prog\valsOffInit[prog\valInit1User] + 1)
  WriteLong(#FILE_OUT, $00CB0001)
  FileSeek(#FILE_OUT, prog\valsOffInit[prog\valInit2User] + 1)
  WriteLong(#FILE_OUT, $00CB0001)
EndIf
;
If (prog\valsNumChng >= 1)
  FileSeek(#FILE_OUT, prog\valsOffChng[prog\valChng1User] + 1)
  WriteLong(#FILE_OUT, $00CB0001)
EndIf
;
If (prog\valsNumFull = 1)
  FileSeek(#FILE_OUT, prog\valsOffFull[0] + 3)
  WriteAsciiCharacter(#FILE_OUT, $00)
ElseIf (prog\valsNumFull > 1)
  FileSeek(#FILE_OUT, prog\valsOffFull[prog\valFull1User] + 3)
  WriteAsciiCharacter(#FILE_OUT, $00)
  FileSeek(#FILE_OUT, prog\valsOffInit[prog\valFull2User] + 3)
  WriteAsciiCharacter(#FILE_OUT, $00)
EndIf
;
CloseFile(#FILE_OUT)
;
ProcedureReturn #True
EndProcedure
;
;-
;
;*
; Start()
; Start the Patching-Process
; 
; @param  void  
; @return void 
;**
Procedure Start()
Protected.i listPos, result = #True
Shared      prog.STUFF
;
SetStartStates(#True)
SetStartStates(#STS_PROC_START)
SetListEntry("")
;
If (GetGadgetState(#G_CHK_FILE))
  listPos = SetListEntry("Erstelle Backup... ")
  If (BackupExecutable())
    SetListEntry("Erstelle Backup... Ok", listPos)
  Else
    SetListEntry("Erstelle Backup... Fehler", listPos)
    SetListEntry("Vorgang abgebrochen")
    SetStartStates(#False)
    SetStatus(#STS_PROC_CNCLD)
    ProcedureReturn
  EndIf
EndIf
;
If (GetGadgetState(#G_CHK_WIND))
  prog\curMode = #MODE_INIT
  result = DoSearch()
  ;
  If (result)
    prog\curMode = #MODE_CHNG
    result = DoSearch()
  EndIf
EndIf
;
If (result)
  prog\curMode = #MODE_FULL
  result = DoSearch()
EndIf
;
If (result)
  DoPatch()
EndIf
;
EndProcedure
;
;*
; DoSearch()
; Search for entries inside the 'fate2.exe'-memory
; 
; @param  void
; @return bool 
;**
Procedure.i DoSearch()
Protected.i listPos, found, limit
Shared       prog.STUFF
;
If (prog\curMode = #MODE_INIT)
  limit   = 2
  listPos = SetListEntry("Suche Werte(Window: init)...")
  found   = SearchValuesInit()
  SetListEntry("Suche Werte(Window: init)... " + Str(found) + " gefunden", listPos)
ElseIf (prog\curMode = #MODE_CHNG)
  limit   = 1
  listPos = SetListEntry("Suche Werte(Window: change)...")
  found   = SearchValuesChange()
  SetListEntry("Suche Werte(Window: change)... " + Str(found) + " gefunden", listPos)
Else
  limit   = 2
  listPos = SetListEntry("Suche Werte(Fullscreen)...")
  found   = SearchValuesFull()
  SetListEntry("Suche Werte(Fullscreen)... " + Str(found) + " gefunden", listPos)  
EndIf  
;
If ((found = 0) Or (found = #VALS_MAX))
  If (found = 0)
    SetListEntry("Vorgang abgebrochen - Keine Werte.")
  Else
    SetListEntry("Vorgang abgebrochen - Zu viele Werte")
  EndIf
  SetStartStates(#False)
  SetStatus(#STS_PROC_CNCLD)
  ProcedureReturn #False
EndIf
;
If (found > limit)
  FillListVals()
  SubMain()
  HideGadget(#G_CNT_VALS, #True)
  HideGadget(#G_CNT_PRGS, #False)
EndIf
;
ProcedureReturn #True
EndProcedure
;
;*
; DoPatch()
; Starts the Patching-Process
; 
; @param  bool
; @return void 
;**
Procedure DoPatch()
Protected.i listPos, result
;
listPos = SetListEntry("Patch Executable...")
result  = PatchExecutable()
;
If (result)
  SetListEntry("Patch Executable... Ok", listPos)
  SetListEntry("Vorgang erfolgreich")
  SetStatus(#STS_PROC_SUCCS)
  MessageRequester("Info", "Fate2 erfolgreich gepatched!")
Else
  SetListEntry("Patch Executable... Fehler", listPos)
  SetListEntry("Vorgang abgebrochen")
  SetStartStates(#False)
  SetStatus(#STS_PROC_CNCLD)
EndIf
; 
EndProcedure
;
;*
; SetStartStates(state.i)
; Dis-/Enables some controls on start of the Patching-Process
; 
; @param  bool
; @return void 
;**
Procedure SetStartStates(state.i)
  DisableGadget(#G_BTN_FILE,  state)
  DisableGadget(#G_BTN_START, state)
  DisableGadget(#G_CHK_FILE,  state)
  DisableGadget(#G_CHK_WIND,  state)
EndProcedure
;
;*
; SetListEntry(text.s, pos.i = -1)
; Adds a List-Entry
; 
; @param  String: 
; @param  Int: 
; @return Int: 
;**
Procedure.i SetListEntry(text.s, pos.i = -1)
Static.i position
;
If (text = #NULL$)
  ClearGadgetItems(#G_LST_PRGS)
  position = 0
ElseIf (pos > -1)
  SetGadgetItemText(#G_LST_PRGS, pos, text)  
Else
  AddGadgetItem(#G_LST_PRGS, position, text)
  position + 1
  ProcedureReturn position - 1
EndIf
;
EndProcedure
;
;*
; FillListValsInit()
; Makes changes to the List
; 
; @param  void 
; @return void 
;**
Procedure FillListVals()
Protected.i item
Shared      prog.STUFF
;
ClearGadgetItems(#G_LST_VALS)
;
If (prog\curMode = #MODE_INIT)
  SetGadgetText(#G_FRM_VALS, "Offsets(Window: init): 2 Auswählen")
  For item = 0 To prog\valsNumInit - 1
    AddGadgetItem(#G_LST_VALS, item, Str(item + 1) + ". Offset: " + Str(prog\valsOffInit[item]))
  Next
ElseIf (prog\curMode = #MODE_CHNG)
  SetGadgetText(#G_FRM_VALS, "Offsets(Window: change): 1 Auswählen")
  For item = 0 To prog\valsNumChng - 1
    AddGadgetItem(#G_LST_VALS, item, Str(item + 1) + ". Offset: " + Str(prog\valsOffChng[item]))
  Next
Else   
  SetGadgetText(#G_FRM_VALS, "Offsets(Fullscreen): 2 Auswählen")
  For item = 0 To prog\valsNumFull - 1
    AddGadgetItem(#G_LST_VALS, item, Str(item + 1) + ". Offset: " + Str(prog\valsOffFull[item]))
  Next
EndIf
;
HideGadget(#G_CNT_PRGS, #True)
HideGadget(#G_CNT_VALS, #False)
;
EndProcedure
;
;*
; CheckListVals()
; Check and get User-selcted List-Values
; 
; @param  void 
; @return void 
;**
Procedure CheckListVals()
Protected.i item, cnt, sel
Shared      prog.STUFF
Dim         vals.i(#VALS_MAX)
;
cnt = CountGadgetItems(#G_LST_VALS) - 1
;
For item = 0 To cnt
  If (GetGadgetItemState(#G_LST_VALS, item))
    vals(sel) = item
    sel + 1
  EndIf
Next
;
If ((prog\curMode = #MODE_INIT) And (sel = 2))
  prog\valInit1User = vals(0)
  prog\valInit2User = vals(1)
  DisableGadget(#G_BTN_VALS, #False)
ElseIf ((prog\curMode = #MODE_CHNG) And (sel = 1))
  prog\valChng1User = vals(0)
  DisableGadget(#G_BTN_VALS, #False)
ElseIf ((prog\curMode = #MODE_FULL) And (sel = 2))  
  prog\valFull1User = vals(0)
  prog\valFull2User = vals(1)
  DisableGadget(#G_BTN_VALS, #False)
Else
  DisableGadget(#G_BTN_VALS, #True)
EndIf
;
EndProcedure
;
;*
; SearchValuesInit()
; Search for values for: Window-Init
; 
; @param  void
; @return bool: 
;**
Procedure.i SearchValuesInit()
Protected.i offset, max, cnt, byte, success
Shared      prog.STUFF
Shared      valsInit.i()
;
max = prog\sizeExe - 1024; no need to search to the end
;
For offset = 0 To max
  For cnt = 0 To 5
    byte = PeekA(prog\memExe + offset + cnt)
    If (byte <> valsInit(cnt)) : Break : EndIf
    If (cnt = 5)
      prog\valsOffInit[success] = offset
      prog\valsNumInit = success + 1
      success + 1
      If (success = #VALS_MAX) : Break 2 : EndIf
    EndIf
  Next
Next
;
ProcedureReturn success
EndProcedure
;
;*
; SearchValuesChange()
; ; Search for values for: Window-Change
; 
; @param  void
; @return bool: 
;**
Procedure.i SearchValuesChange()
Protected.i offset, max, cnt, byte, success
Shared      prog.STUFF
Shared      valsChng.i()
;
max = prog\sizeExe - 1024; no need to search to the end
;
For offset = 0 To max
  For cnt = 0 To 5
    byte = PeekA(prog\memExe + offset + cnt)
    If (byte <> valsChng(cnt)) : Break : EndIf
    If (cnt = 5)
      prog\valsOffChng[success] = offset
      prog\valsNumChng = success + 1
      success + 1
      If (success = #VALS_MAX) : Break 2 : EndIf
    EndIf
  Next
Next
;
ProcedureReturn success
EndProcedure
;
;*
; SearchValuesFull()
; Search for values for Fullscreen-Modi
; 
; @param  void
; @return bool: 
;**
Procedure.i SearchValuesFull()
Protected.i offset, max, cnt, byte, success
Shared      prog.STUFF
Shared      valsFull.i()
;
max = prog\sizeExe - 1024; no need to search to the end
;
For offset = 0 To max
  For cnt = 0 To 5
    byte = PeekA(prog\memExe + offset + cnt)
    If (byte <> valsFull(cnt)) : Break : EndIf
    If (cnt = 5)
      prog\valsOffFull[success] = offset
      prog\valsNumFull = success + 1
      success + 1
      If (success = #VALS_MAX) : Break 2 : EndIf
    EndIf
  Next
Next
;
ProcedureReturn success
EndProcedure
;
;
;-
;***
;----------------------------------------------->
;- Procedures (Win-API):
;-
;

; IDE Options = PureBasic 4.41 (Windows - x86)
; Folding = ----
; EnableUnicode
; EnableXP
; EnableUser
; UseIcon = f2_tools.ico
; Executable = ..\Fate2-Framery_32.exe
; DisableDebugger
; EnableBuildCount = 2